#pragma once

#include "Core.h"
#include <string>
#include <memory>

class FluxEngine;

class FLUX_API BaseObject
{
public:
    BaseObject(FluxEngine* Engine);
    BaseObject() = default;
    virtual ~BaseObject();

    virtual void Destroy();

    virtual void Init();

    static bool IsUnreachable(BaseObject* Object);

    virtual bool IsValid();

    std::string GetName() const;

    FluxEngine* GetEngine() const;

private:
    mutable FluxEngine* _CachedEngine = nullptr;
    bool bIsInitialized = false;
    bool bUnreachable = false;
    std::string _Name = "";
};